# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gmplot_msgs/PlotMapRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import gmplot_msgs.msg

class PlotMapRequest(genpy.Message):
  _md5sum = "2a0f7f3245b39061195bd7b8ec0ef34b"
  _type = "gmplot_msgs/PlotMapRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool save_map


string filename
float64 center_lat
float64 center_lon
uint8 zoom
bool satellite_view

gmplot_msgs/PlotPoint[] points


================================================================================
MSG: gmplot_msgs/PlotPoint
float64 lat                     # Latitude of the graphic
float64 lon                     # Longitude of the graphic

string text                     # Text label of the marker. Only used for
                                # TEXT_LABEL and MARKER_WITH_TEXT types

uint8 size                      # Size of the graphic placed on map. Only used for
                                # SCATTER_POINT and LINE types
                                
string color                    # Color of graphic placed on map
                                #   Single character (b, g, r, c, m, y, k, w)
                                #   HTML color names (aliceblue, chartreuse, etc.)
                                #   HTML color codes (#123ABC, #FFFFFF, etc.)

uint8 SCATTER_POINT=0           # Individual circles with radius equal to the size field
uint8 LINE=1                    # Connected dots with line width equal to the size field
uint8 MARKER=2                  # Pin marker
uint8 TEXT_LABEL=3              # Text marker
uint8 MARKER_WITH_TEXT=4        # Both pin and text
uint8 type
"""
  __slots__ = ['save_map','filename','center_lat','center_lon','zoom','satellite_view','points']
  _slot_types = ['bool','string','float64','float64','uint8','bool','gmplot_msgs/PlotPoint[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       save_map,filename,center_lat,center_lon,zoom,satellite_view,points

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PlotMapRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.save_map is None:
        self.save_map = False
      if self.filename is None:
        self.filename = ''
      if self.center_lat is None:
        self.center_lat = 0.
      if self.center_lon is None:
        self.center_lon = 0.
      if self.zoom is None:
        self.zoom = 0
      if self.satellite_view is None:
        self.satellite_view = False
      if self.points is None:
        self.points = []
    else:
      self.save_map = False
      self.filename = ''
      self.center_lat = 0.
      self.center_lon = 0.
      self.zoom = 0
      self.satellite_view = False
      self.points = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_get_struct_B().pack(self.save_map))
      _x = self.filename
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2d2B().pack(_x.center_lat, _x.center_lon, _x.zoom, _x.satellite_view))
      length = len(self.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.points:
        _x = val1
        buff.write(_get_struct_2d().pack(_x.lat, _x.lon))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_get_struct_B().pack(val1.size))
        _x = val1.color
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_get_struct_B().pack(val1.type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.points is None:
        self.points = None
      end = 0
      start = end
      end += 1
      (self.save_map,) = _get_struct_B().unpack(str[start:end])
      self.save_map = bool(self.save_map)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.filename = str[start:end].decode('utf-8')
      else:
        self.filename = str[start:end]
      _x = self
      start = end
      end += 18
      (_x.center_lat, _x.center_lon, _x.zoom, _x.satellite_view,) = _get_struct_2d2B().unpack(str[start:end])
      self.satellite_view = bool(self.satellite_view)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points = []
      for i in range(0, length):
        val1 = gmplot_msgs.msg.PlotPoint()
        _x = val1
        start = end
        end += 16
        (_x.lat, _x.lon,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8')
        else:
          val1.text = str[start:end]
        start = end
        end += 1
        (val1.size,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.color = str[start:end].decode('utf-8')
        else:
          val1.color = str[start:end]
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        self.points.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_get_struct_B().pack(self.save_map))
      _x = self.filename
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2d2B().pack(_x.center_lat, _x.center_lon, _x.zoom, _x.satellite_view))
      length = len(self.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.points:
        _x = val1
        buff.write(_get_struct_2d().pack(_x.lat, _x.lon))
        _x = val1.text
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_get_struct_B().pack(val1.size))
        _x = val1.color
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_get_struct_B().pack(val1.type))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.points is None:
        self.points = None
      end = 0
      start = end
      end += 1
      (self.save_map,) = _get_struct_B().unpack(str[start:end])
      self.save_map = bool(self.save_map)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.filename = str[start:end].decode('utf-8')
      else:
        self.filename = str[start:end]
      _x = self
      start = end
      end += 18
      (_x.center_lat, _x.center_lon, _x.zoom, _x.satellite_view,) = _get_struct_2d2B().unpack(str[start:end])
      self.satellite_view = bool(self.satellite_view)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.points = []
      for i in range(0, length):
        val1 = gmplot_msgs.msg.PlotPoint()
        _x = val1
        start = end
        end += 16
        (_x.lat, _x.lon,) = _get_struct_2d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.text = str[start:end].decode('utf-8')
        else:
          val1.text = str[start:end]
        start = end
        end += 1
        (val1.size,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.color = str[start:end].decode('utf-8')
        else:
          val1.color = str[start:end]
        start = end
        end += 1
        (val1.type,) = _get_struct_B().unpack(str[start:end])
        self.points.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_2d2B = None
def _get_struct_2d2B():
    global _struct_2d2B
    if _struct_2d2B is None:
        _struct_2d2B = struct.Struct("<2d2B")
    return _struct_2d2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from gmplot_msgs/PlotMapResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class PlotMapResponse(genpy.Message):
  _md5sum = "d41d8cd98f00b204e9800998ecf8427e"
  _type = "gmplot_msgs/PlotMapResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
"""
  __slots__ = []
  _slot_types = []

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PlotMapResponse, self).__init__(*args, **kwds)

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      pass
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      pass
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
class PlotMap(object):
  _type          = 'gmplot_msgs/PlotMap'
  _md5sum = '2a0f7f3245b39061195bd7b8ec0ef34b'
  _request_class  = PlotMapRequest
  _response_class = PlotMapResponse
